DAT programName byte "AX12WithIrControl101217b"
CON
{{ 
  modified from AX12FindChangeIdBaud101129a.spin  
  Needs to communicate with other flight control Prop (future).
  Also communicates with HoBo for text overlay on video signal.
  LCD or LED display?  Probably just text on video.
  May want gyros to help keep camera pointed straight.
  Use alerion and elevator controls for pan and tilt.
  Use throtle for zoom control.  Gear will control shutter?
  I wish I could switch between video and still photos remotely.
  Version 101204d keep pulse in info raw until it's needed.
  j kind of works.  The AX12s turn as expected (sort of).   The
  zoom goes on too long but does work.  The photoshot button doesn't
  work yet.  k use different Photoshot code.  05a change zoom to
  flap (aux1) channel.  Change in gear switch triggers photoshot.
  5a is not working.  AX12 turn one direction only with stick
  movement.  They then return to start (one extreme) when stick
  returns to center.  d is kind of working.  7a add ADC to track
  main heli power battery.  Add communication to Propeller
  Backpack.  Merge coms to use 4com in one.
  Version 101216b works with Overlay101216a.spin.
  16c add all the stuff I took out to get overlay to work.
  c doesn't work.  d take stuff back out and it works again.
  e add some stuff back, still working.  If I add a call to
  Zoom method, it doesn't work.  I think PulseIn method is the
  problem.  g monitor pulses from radio in separate cog.  The
  communication with the BackPack is working.  k works!  l is
  pretty good.
  Cog0 MainLoop
  Cog1 UART
  Cog2 WatchAX12s
  Cog3 AX12 com?
  Cog4 IR control

  
}}
                                              
  _clkmode = xtal1 + pll16x                       'set propeller clock rate
  _xinfreq = 5_000_000                            '

  ' Pin asignments

  _BackpackPin = 8              '9 
  _IrLed = 10
  _AdcClock = 11
  _AdcData = 12
  _AdcCs = 13                   ' 10 bit ADC only one channel used right now.  Monitors heli motor battery voltage.
  _AX12Pin = 16                 ' through 1K resistor pulled high (3.3V) with 10K.
  radioIn0 = 17
  radioIn1 = 18                 ' PWM from radio through 10K resistors.   
  radioIn2 = 19                 ' PWM from radio through 10K resistors.   
  radioIn3 = 20
  radioIn4 = 21
  radioIn5 = 22
  radioIn6 = 23
  _Adc8Clock = 24
  _Adc8Data = 25
  _Adc8Cs = 26

  
  _CameraBatteryConstant = 3907 'divide by 1000_000      
  _HeliBatteryConstant = 685 'divide by 1000      
  _MidPulse = 15000
  _SwitchHigh = _MidPulse + 2000
  _SwitchLow = _MidPulse - 2000
  _StickHigh = _MidPulse + 1000
  _StickLow = _MidPulse - 1000 
  _PulseComplianceMargin = 200   ' ** This will need to be adjusted
  _PulseToLoopConstant = 1000 '250    ' ** This will need to be adjusted
  _MidAX12 = 512
  _MaxAX12 = 1023
  _MinAX12 = -1023
  _AX12TiltLimitCW = $133       '307 ' ** This will need to be adjusted
  _AX12TiltLimitCCW = $2CD      '717 ' ** This will need to be adjusted
  _InitSpeed = 0 '$200             ' ** This will need to be adjusted
  _MaxSpeed = $3FF              ' ** This may need to be adjusted
  _DefaultTorque = $300         ' ** This will need to be adjusted
  _PhotoShotRepeats = 5         ' ** This will need to be adjusted
  _SpeedPerDistance = 2         ' ** This will need to be adjusted
  _MaxSpeedJump = 5             ' ** This will need to be adjusted
  _NumberOfChannels = 7
  _StackSize = 64
  _LiPoCellLowV = 375
  _DebugBaud = 115200 '9600 
  _BackpackBaud = 9600
  _AxBaud = 250_000  
  

  ' radio channels enumerated
  #0, _Throttle, _Pan, _Tilt, _Rudder, _Photo, _Zoom, _Center

  ' AX-12+s enumerated
  #0, _Ax12Pan, _AX12Tilt

  ' communication ports enumerated
  #0, _Debug, _Backpack

  ' batteries enumerated
  #0, _HeliBattery, _CameraBattery

  TPT           = 0             'Change this to 1 for video sources that do not work well with
                                'opaque overlays.
  TPTor0        = ((TPT == 0) | TPT) & _0
  
  'Commands recognized by "out" method.  (Use these codes to control BackPack)

  CLS           = $00           '( ) Clear the current window, and home cursor.
  HOME          = $01           '( ) Move cursor to home position.
  CRSRXY        = $02           '(col,row) Move cursor to col and row.
  CRSRLF        = $03           '( ) Move cursor to the left.
  CRSRRT        = $04           '( ) Move cursor to the right.
  CRSRUP        = $05           '( ) Move cursor up.
  CRSRDN        = $06           '( ) Move cursor down.
  SHODSP        = $07           '(dispno) Show display number dispno.
  BKSP          = $08           '( ) Erase prior character and move cursor left.
  TAB           = $09           '( ) Move cursor right to next column divisible by 8.
  LF            = $0A           '( ) Linefeed. Scroll up if on bottom line.
  CLREOL        = $0B           '( ) Clear to the end of the current line.
  CLRDN         = $0C           '( ) Clear from cursor position to the end of the window.
  CR            = $0D           '( )Carriage return. Scroll up if necessary.
  CRSRX         = $0E           '(col) Move cursor to column col.
  CRSRY         = $0F           '(row) Move cursor to row.
  DEFWIN        = $10           '(winno,cols,rows) Define a new window winno sized cols x rows. Make it the current window.
  USEWIN        = $11           '(winno) Change the current window to winno.
  CHGCLR        = $12           '(mask,transparent,fgnd,bkgd) Change current window color to mask, transparent, fgnd, and bkgd.
  SCROLL        = $13           '(offset) Set X (one-line) or Y (multi-line) scroll offset (0 - 15) for current window.
  SMSCRL        = $14           '(rate) Set smooth scrolling rate in current window to rate ms/scan line.
  WDWRAP        = $15           '(yn) Set word wrapping for current window: on (yn<>0) or off (yn==0).
  BLINK         = $16           '(yn) Set blinking for current window: on (yn<>0) or off (yn==0).
  CPYWIN        = $17           '(winno) Copy the text from winno to current window.
  APNDSP        = $18           '(disp,winno,x,y) Append window winno to display disp at location (x,y).
  MOVWIN        = $19           '(slot,x,y) Move window in slot to (x,y).
  SHOWIN        = $1A           '(slot,yn) Show window in slot: yes (yn<>0) or no (yn==0).
  CHGWIN        = $1B           '(slot,winno) Change window in slot to winno.
  PRESET        = $1C           '(dispno,presetno) Create display dispno using preset presetno.
  SETTIM        = $1D           '(yr,mo,day,hr,min,sec) Set the current time.
  MARK          = $1E           '( )Return MARK to acknowledge reaching this point.
  ESC           = $1F           '(char) Escape next character char (i.e. print as-is).

  CLRWIN        = $FF           '( )Same as CLS where strings do not permit 0.
  NONE          = $FF           'Same as 0 when used as an argument.
  ZERO          = $FF           'Same as 0 when used as an argument.
  _0            = $FF           'Same as 0 when used as an argument.
  NO            = $FF           'Same as 0 when used as an argument.
  YES           = $01           'Canonical non-zero value used for binary choices.

  DBL           = $80           'OR with height and width arguments to get double-sized characters.
  SHO           = $40           'OR with window number to set visibility on.

  'Preset names.

  BIGWIN        = $01           '40 x 13 regular window.
  CREDITS       = $02           'Vertically overscanned window with smooth scrolling.
  MARQUEE       = $03           'Single row at bottom with smooth scrolling.
  HILO          = $04           'Single rows top and bottom.
  HILO2         = $05           'Dual rows top and bottom.
  CROSS         = $06           'Single cross-shaped cursor in middle of 40 x 13 screen.
  BOX           = $07           'Single box-shaped cursor in middle of 40 x 13 screen.
  DOT           = $08           'Single dot cursor in middle of 40 x 13 screen.

  ' Window type names.

  REGWIN        = 0             'Regular window.
  HMS24         = 1             'Time window:  23:59:59
  HMS12         = 2             'Time window: 12:59:59pm
  YMD           = 3             'Date window: 2099-12-31
  MDY           = 4             'Date window: 12/31/2099
  DMY           = 5             'Date window: 31-12-2099
  YMDHMS24      = 6             'Date/time window: 2099-12-31 23:59:59
  MDYHMS12      = 7             'Date/time window: 12/31/2099 12:59:59pm
  DMYHMS12      = 8             'Date/time window: 31-12-2099 12:59:59pm
  
VAR

  'long globalIdNumber, globalRegister4
  long presentPosition[2], targetPosition[2], presentSpeed[2], targetSpeed[2]
  long dynaBufferAddr, dynaRxBufferAddr, ax12Stack[_StackSize], irStack[_StackSize]
  long hundredns      ' 100 nano seconds
  long oldPulse[_NumberOfChannels], globalHighEdge, globalLowEdge, globalTorque[2]
  long globalZoom, watchLoop, globalCodePtr, globalLength, globalRepeatCode
  long pulseStack[_StackSize], globalPulse[_NumberOfChannels], voltage[2], voltageOld[2] 
  byte controller[2]
  byte radioIn[_NumberOfChannels], globalPhoto, globalPin
  
OBJ

  'Debug : "FullDuplexSerial" 
  Dynamixel : "dynacomv1.2DWD"
  Freq : "Synth"
  Adc : "MCP3002_1a"
  Adc8 : "MCP3208_fast"       
  Com : "pcFullDuplexSerial4FC"
  io : "basic_sio8"
   
PUB Main | localIndex

  'initialization
  controller[_Ax12Pan] := 7            ' Pan These are test AX-12+s change for final
  controller[_AX12Tilt] := 8            ' Tilt
  voltageOld[0] := 0
  voltageOld[1] := 0
  radioIn[_Throttle] := radioIn0                 ' PWM from radio through 10K resistors.
  radioIn[_Pan] := radioIn1
  radioIn[_Tilt] := radioIn2
  radioIn[_Rudder] := radioIn3
  radioIn[_Photo] := radioIn4
  radioIn[_Zoom] := radioIn5
  radioIn[_Center] := radioIn6   
  outa[_BackpackPin] := 0
  dira[_BackpackPin] := 1                               ' reset backpack
  waitcnt(clkfreq / 2 + cnt)
  dira[_BackpackPin] := 0
  Adc.Start(_AdcCs, _AdcClock, _AdcData)
  Adc8.start(_Adc8Data, _Adc8Clock, _Adc8Cs, %1)
  waitcnt(clkfreq * 2 + cnt)  
  globalHighEdge := _MidPulse + (_PulseComplianceMargin * 3)
  globalLowEdge := _MidPulse - (_PulseComplianceMargin * 3)   
  io.start
  
  Com.Init      
  Com.AddPort(_Debug, 31, 30, -1, -1, 0, 0, _DebugBaud)
  'Com.AddPort(_Backpack, _BackpackPin, _BackpackPin, -1, -1, 0, {%10}0, _BackpackBaud)  }
  'Com.AddPort(_Spectrometer, _SpectrometerPinRx, -1, -1, -1, 0, 0, _SpectrometerBaud)
  'Com.AddPort(_Barcode, _BarcodeData, -1, -1, -1, 0, 0, _BarcodeBaud)
  Com.Start
  waitcnt(clkfreq / 10 + cnt)
  
  hundredns := clkfreq / 10_000_000
  repeat localIndex from 0 to _NumberOfChannels - 1
    oldPulse[localIndex] := _MidPulse
  cognew(WatchAX12s, @ax12Stack)  
  cognew(Playcode, @irStack)  
  cognew(MonitorPulse, @pulseStack)  

  waitcnt(clkfreq / 4 + cnt) 
  PingAndTest(controller[0])
  PingAndTest(controller[1])
  MainLoop
  
PUB MainLoop | photoFlag, oldPhotoFlag, localTemp[2]
  ' radio channels enumerated
  '#0, _Zoom, _Pan, _Tilt, _Rudder, _Photo, _Aux1, _Aux2
  '_HeliBattery, _CameraBattery
  photoFlag := 2
 { io.str(string(DEFWIN, 1, 6, 1))
  io.str(string(DEFWIN, 2, 6, 1))
  io.str(string(DEFWIN, 3, 5, 1))
  io.str(string(DEFWIN, 4, 6, 1))
  io.str(string(APNDSP, 1, 1, 2, 11))
  io.str(string(APNDSP, 1, 2, 9, 11))
  io.str(string(APNDSP, 1, 3, 2, 2))
  io.str(string(APNDSP, 1, 4, 9, 2))
  io.str(string(USEWIN, 1, "Heli = "))
  io.str(string(USEWIN, 3, "Cam = "))
  io.str(string(SHODSP, 1))
  io.str(string(SHO | 1, SHODSP, 1   }
  'io.str(string(DEFWIN, 10, {DBL | 15, DBL | 2,} CHGCLR, $f, _0, 8|TPT, 1, APNDSP, 10, SHO|10, _0, 20, SHODSP, 10, WDWRAP, 1))
  io.str(string(DEFWIN, 10, SHO | 15, SHO | 2, CHGCLR, $f, _0, 8|TPT, 1, APNDSP, 10, SHO|10, _0, 20, SHODSP, 10, WDWRAP, 1))
  'pr.str(string(DEFWIN, 60, _0, HMS24, CHGCLR, $f, _0, _0, 8|TPT, APNDSP, 10, SHO|60, 100, 200, SETTIM, _0, _0, _0, _0, _0, _0))
  'io.str(string(USEWIN, 10, "Heli = ", CR))
  'io.str(string(_0, CRSRXY, 3, 2, "Heli = ", CR))
  'waitcnt(clkfreq * 2 + cnt) 
  repeat
    
    oldPhotoFlag := photoFlag
    'Com.str(_Debug, string(13, "Beginning of Main Loop"))
    
    globalZoom := Zoom
    'Com.str(_Debug, string(13, "globalZoom = "))
    'Com.dec(_Debug, globalZoom)
    localTemp := CenterAx12s 
    if localTemp == 0
      AdjustAX12(_AX12Pan, _Pan)
      AdjustAX12(_AX12Tilt, _Tilt)
    'io.str(string("Hello, world!"))
    'io.out(0)'HOME)
    'waitcnt(clkfreq * 2 + cnt)
    io.str(string(CRSRXY, 3, 1, "Heli = "))
    'waitcnt(clkfreq * 2 + cnt)
    'io.out("V")
    'waitcnt(clkfreq * 2 + cnt) 
    voltage[_HeliBattery] := Adc.GetADC(0) * _HeliBatteryConstant / 1000
    'io.out("V")
    'waitcnt(clkfreq * 2 + cnt) 
    'io.out(HOME)
    'io.str(string(USEWIN, 10, "Heli = "))
    localTemp[0] := voltageOld[_HeliBattery] / 1000
    localTemp[1] := voltage[_HeliBattery] / 1000
    PseudoRealOverlay(10, voltage[_HeliBattery], 2)
    'waitcnt(clkfreq * 2 + cnt) 
    io.out("V")
    if localTemp[0] > 0 and localTemp[1] == 0
      io.out(32)
    if voltage[_HeliBattery] =< _LiPoCellLowV * 6
      io.str(string("  *** Warning Low Battery ***"))
    voltage[_CameraBattery] := Adc8.average(0, 8) *  _CameraBatteryConstant / 10000
    
    'voltage[_CameraBattery] := Adc8.in(0) *  _CameraBatteryConstant / 10000
    io.str(string(13, CRSRXY, 3, 2, "Camera = "))
    'PseudoRealOverlay(10, voltage[_CameraBattery], 2)
    localTemp[0] := voltageOld[_CameraBattery] / 1000
    localTemp[1] := voltage[_CameraBattery] / 1000
    PseudoRealOverlay(10, voltage[_CameraBattery], 2)
    io.out("V")
    'io.out(32) 
    if (localTemp[0] > 0) and (localTemp[1] == 0)
      io.out(32)
    if voltage[_CameraBattery] =< _LiPoCellLowV * 2
      io.str(string("  *** Warning Low Battery ***"))
     
    voltageOld[_HeliBattery] := voltage[_HeliBattery]
    voltageOld[_CameraBattery] := voltage[_CameraBattery]
    'waitcnt(clkfreq * 2 + cnt) 
    'io.str(string(SHODSP, 1)) 
    'Com.dec(_Debug, globalPulse[radioIn[_Rudder]]) 
    'waitcnt(clkfreq / 2 + cnt)  
    globalPhoto := PhotoShot
    'Com.str(_Debug, string(13, "globalPhoto = "))
    'Com.dec(_Debug, globalPhoto) 
    'DisplayChannels
    'display                                       'display data
   
PUB Zoom | {localProportional, localHighEdge, localLowEdge,} localZoom

  'localHighEdge := _MidPulse * 11 / 10
  'localLowEdge := _MidPulse * 9 / 10
  localZoom := globalPulse[radioIn[_Zoom]]
  'if ||(localZoom - oldPulse[_Zoom]) =< _PulseComplianceMargin
    'return
  if localZoom > _SwitchHigh
    'localProportional := (localZoom - _SwitchHigh) / _PulseToLoopConstant
    repeat while globalCodePtr <> 0
    globalRepeatCode := 1 'localProportional
    globalLength := 127
    globalCodePtr := @IR00
  elseif localZoom < _SwitchLow
    'localProportional := (_SwitchLow - localZoom) / _PulseToLoopConstant
    repeat while globalCodePtr <> 0
    globalRepeatCode := 1 'localProportional
    globalLength := 127
    globalCodePtr := @IR01
  oldPulse[_Zoom] := localZoom
  result := localZoom
      
PUB PhotoShot | {localHighEdge, localLowEdge,} localPulse

  result := 0
  {_SwitchHigh := _MidPulse * 15 / 10
  Com.str(_Debug, string(13, "_SwitchHigh = "))
  Com.dec(_Debug, _SwitchHigh)
  localLowEdge := _MidPulse * 5 / 10
  Com.str(_Debug, string(13, "localLowEdge = "))
  Com.dec(_Debug, localLowEdge) }
  localPulse := globalPulse[radioIn[_Photo]]
  'Com.str(_Debug, string(13, "localPulse = "))
  'Com.dec(_Debug, localPulse)
  'Com.str(_Debug, string(13, "|| = "))
  '.dec(||(localPulse - oldPulse[_Photo]))
  if ||(localPulse - oldPulse[_Photo]) =< _PulseComplianceMargin * 10
    return
  else ' localPulse > _SwitchHigh and oldPulse[_Photo] =< _SwitchHigh
    repeat while globalCodePtr <> 0
      Com.str(_Debug, string(13, "PhotoShot waiting globalCodePtr = "))
      Com.dec(_Debug, globalCodePtr)
    globalRepeatCode := _PhotoShotRepeats
    globalLength := 127
    globalCodePtr := @IR04
    'Com.str(_Debug, string(13, "globalCodePtr = "))
    'Com.dec(_Debug, globalCodePtr)
    result := 1
  oldPulse[_Photo] := localPulse
      
PUB CenterAx12s | {localHighEdge, localLowEdge,} localPulse

  result := 0
  {_SwitchHigh := _MidPulse * 15 / 10
  Com.str(_Debug, string(13, "_SwitchHigh = "))
  Com.dec(_Debug, _SwitchHigh)
  localLowEdge := _MidPulse * 5 / 10
  Com.str(_Debug, string(13, "localLowEdge = "))
  Com.dec(_Debug, localLowEdge) }
  localPulse := globalPulse[radioIn[_Center]]
  'Com.str(_Debug, string(13, "localPulse = "))
  'Com.dec(_Debug, localPulse)
  'Com.str(_Debug, string(13, "|| = "))
  '.dec(||(localPulse - oldPulse[_Center]))
  if ||(localPulse - oldPulse[_Center]) =< _PulseComplianceMargin * 10
    return
  else ' localPulse > _SwitchHigh and oldPulse[_Center] =< _SwitchHigh
    targetPosition[0] := _MidAX12
    targetPosition[1] := _MidAX12
    result := 1
  oldPulse[_Center] := localPulse
      
PUB AdjustAX12(localController, localChannel) | localPulse , localTargetP, localProportional
    
  localPulse := globalPulse[radioIn[localChannel]]
  {Com.str(_Debug, string(13, 13, "localPulse with ID# "))
  Com.dec(_Debug, controller[localController])
  Com.str(_Debug, string(13, "radioIn["))
  Com.dec(_Debug, localChannel)
  Com.str(_Debug, string("] = "))
  Com.dec(_Debug, radioIn[localChannel])
  Com.str(_Debug, string(13, "localPulse = "))
  Com.dec(_Debug, localPulse)
  Com.str(_Debug, string(13, "a) targetPosition["))
  Com.dec(_Debug, localController)
  Com.str(_Debug, string("] = "))
  Com.dec(_Debug, targetPosition[localController])
  }
  'if ||(localPulse - oldPulse[localChannel]) =< _PulseComplianceMargin
    'return
  
  if localPulse > globalHighEdge
    localProportional := (localPulse - globalHighEdge)
    localTargetP := targetPosition[localController] + (localProportional / 100) + 1 ' This might be too extreme
    targetPosition[localController] := 0 #> localTargetP <# $3FF 
  elseif localPulse < globalLowEdge
    localProportional := (globalLowEdge - localPulse)
    localTargetP := targetPosition[localController] - (localProportional / 100) + 1
    targetPosition[localController] := 0 #> localTargetP <# $3FF
  {Com.str(_Debug, string(13, "b) targetPosition["))
  Com.dec(_Debug, localController)
  Com.str(_Debug, string("] = "))
  Com.dec(_Debug, targetPosition[localController])
   }
  'targetPosition[localController] := 0 #> localTargetP <# $3FF  
 { Com.str(_Debug, string(13, "c) targetPosition["))
  Com.dec(_Debug, localController)
  Com.str(_Debug, string("] = "))
  Com.dec(_Debug, targetPosition[localController])
   }
 
PUB PingAndTest(localId) | localIndex, localReadId, localReadReg4, localTemp, localReg4


  localReg4 := ToReg4(_AxBaud)
  Com.str(_Debug, string(13, "PingAndTest method "))
  Com.str(_Debug, string(13, "Testing AX-12+ with ID# "))
  Com.dec(_Debug, localId)
  Com.str(_Debug, string(13, "With baud rate of "))
  Com.dec(_Debug, _AxBaud)
  Com.str(_Debug, string("bps", 13))
 
  repeat localIndex from 1 to 5
    result := 1
    Com.str(_Debug, string(13, "Ping attempt number "))
    Com.dec(_Debug, localIndex)
    localTemp := Dynamixel.ping(LocalId) 
    if localTemp == -1
      Com.str(_Debug, string(13, "Successful Ping")) 
      Com.str(_Debug, string(13, "Reading registers 3 & 4 to make sure."))
      localReadReg4 := Dynamixel.ReadData(localId, 3, 2)
      Com.str(_Debug, string(13, "Raw data = $"))
      Com.hex(_Debug, localReadReg4, 8)
      localReadId := localReadReg4 // $100
      localReadReg4 /=  $100
      if localReadId == localId
        Com.str(_Debug, string(13, "Register 3 (ID#) agrees with expected data."))
        result *= 2
      else
        Com.str(_Debug, string(13, "*********************** Warning ***********************"))
        Com.str(_Debug, string(13, "Register 3 (ID#) does NOT agree with expected data."))
        result *= 3
      Com.str(_Debug, string(13, "Register 3 = "))
      Com.dec(_Debug, localReadId)
      Com.str(_Debug, string(13, "ID# = "))
      Com.dec(_Debug, localId)
      if localReadReg4 == localReg4
        Com.str(_Debug, string(13, "Register 4 agrees with expected data."))
        result *= 5
      else
        Com.str(_Debug, string(13, "*********************** Warning ***********************"))
        Com.str(_Debug, string(13, "Register 4 does NOT agree with expected data."))
        result *= 7
      Com.str(_Debug, string(13, "Register 4 = "))
      Com.dec(_Debug, localReadReg4)
      Com.str(_Debug, string(13, "Expected = "))
      Com.dec(_Debug, localReg4)
      if result == 10
        quit
  'waitcnt(clkfreq / 4 + cnt)
        

PUB ToBaud(localReg4)

  result := 2000000/(localReg4 + 1)

PUB ToReg4(localBaud)

  result := (2000000 / localBaud) - 1

PUB PseudoReal(localValue, decimalShift) | localTemp, localCharacter

  localTemp := 1
  repeat decimalShift
    localTemp *= 10 
  Com.dec(_Debug, localValue / localTemp)    
  Com.tx(_Debug, 46)
  localCharacter := localValue // localTemp
  repeat decimalShift - 1
    localTemp *= 10
    if localCharacter < 10
      Com.tx(_Debug, "0")
  Com.dec(_Debug, localCharacter)
  
PUB PseudoRealOverlay(localWindow, localValue, decimalShift) | localTemp, localCharacter

  localTemp := 1
  repeat decimalShift
    localTemp *= 10
  'io.out(USEWIN)
  'io.out(localWindow)
  
  Dec(localValue / localTemp)
    
  io.out(46)
  localCharacter := localValue // localTemp
  repeat decimalShift - 1
    localTemp *= 10
    if localCharacter < 10
      io.out("0")
  Dec(localCharacter)

PUB Dec(value) | i, x

  x := value == NEGX                                                            'Check for max negative
  if value < 0
    value := ||(value+x)                                                        'If negative, make positive; adjust for max negative
    io.out("-")                                                                     'and output sign

  i := 1_000_000_000                                                            'Initialize divisor

  repeat 10                                                                     'Loop for 10 digits
    if value => i                                                               
      io.out(value / i + "0" + x*(i == 1))                                          'If non-zero digit, output digit; adjust for max negative
      value //= i                                                               'and digit from value
      result~~                                                                  'flag non-zero found
    elseif result or i == 1
      io.out("0")                                                                   'If zero digit (or only digit) output it
    i /= 10                      
  
PUB MonitorPulse | state, localChannel

  repeat
    repeat localChannel from 0 to _NumberOfChannels - 1
      state := 1
      dira[radioIn[localChannel]]~
      ctra := 0
       
      ctra := (%11010 << 26 ) | (%001 << 23) | (0 << 9) | (radioIn[localChannel]) ' set up counter, A level count
       
      frqa := 1
      waitpne(state << radioIn[localChannel], |< radioIn[localChannel], 0)                         ' Wait for opposite state ready
      phsa:=0                                                  ' Clear count
      waitpeq(state << radioIn[localChannel], |< radioIn[localChannel], 0)                         ' wait for pulse
      waitpne(state << radioIn[localChannel], |< radioIn[localChannel], 0)                         ' Wait for pulse to end
      globalPulse[localChannel] := phsa / hundredns + 1                         ' Return duration as 0.1us mulitple
      ctra :=0                                                 ' stop counter
   
PUB Display

  Com.str(_Debug, string(13, 13, "Servo positions",13))
  
  Com.str(_Debug, string(13, 13, "Camera positions",13))
  Com.str(_Debug, string(13, "Pan Present = "))
  Com.dec(_Debug, presentPosition[_Pan])
  Com.str(_Debug, string(13, "Pan Target = "))
  Com.dec(_Debug, targetPosition[_Pan])
  Com.str(_Debug, string(13, "Pan Speed = "))
  Com.dec(_Debug, presentSpeed[_Pan])
  Com.str(_Debug, string(13, "Pan Target Speed = "))
  Com.dec(_Debug, targetSpeed[_Pan])
  
  Com.str(_Debug, string(13, "Pan Torque = "))
  Com.dec(_Debug, globalTorque[_Pan])
  
  Com.str(_Debug, string(13, "Tilt Present = "))
  Com.dec(_Debug, presentPosition[_Tilt])
  Com.str(_Debug, string(13, "Tilt Target = "))
  Com.dec(_Debug, targetPosition[_Tilt])
  Com.str(_Debug, string(13, "Tilt Speed = "))
  Com.dec(_Debug, presentSpeed[_Tilt])
  Com.str(_Debug, string(13, "Tilt Target Speed = "))
  Com.dec(_Debug, targetSpeed[_Tilt])

  Com.str(_Debug, string(13, "Tilt Torque = "))
  Com.dec(_Debug, globalTorque[_Tilt])

  Com.str(_Debug, string(13, "globalZoom = "))
  Com.dec(_Debug, globalZoom)   
  Com.str(_Debug, string(13, "globalPhoto     = "))
  Com.dec(_Debug, globalPhoto)

  Com.str(_Debug, string(13, "watchLoop     = "))
  Com.dec(_Debug, watchLoop)


PUB DisplayChannels

  Com.str(_Debug, string(13, 13, "globalPulse values",13))
  repeat result from 0 to 6
    Com.str(_Debug, string(13, "globalPulse[radioIn["))
    Com.dec(_Debug, result)
    Com.str(_Debug, string("]] = "))
    Com.dec(_Debug, globalPulse[radioIn[result]])
  
PUB playcode | localIndex, localStartTime
   
  Freq.Synth("A",_IrLed, 38_000)
  repeat
    if globalCodePtr <> 0
      repeat globalRepeatCode
        dira[_IrLed]~
        localStartTime := cnt
        repeat localIndex from 0 to globalLength - 1
          !dira[_IrLed]
          waitcnt(localStartTime + long[globalCodePtr][localIndex])
         
        dira[_IrLed]~
        waitcnt(clkfreq / 50 + cnt)
      globalCodePtr := 0
      
PUB WatchAX12s | localIndex, localTargetP[2], localTargetS[2], localPosition[2], localSpeed[2], {                      
'_AX12TiltLimitCW   _InitSpeed     $133 $2CD
               } localOldTP[2], localOldTS[2], localOldP[2], localOldS[2], localTemp
'' in separate cog                                                                                                     
'presentPosition[2], targetPosition[2]

  Dynamixel.start(_AX12Pin, _AxBaud)
  waitcnt(clkfreq + cnt)
  dynaBufferAddr := Dynamixel.GetBufferAddr
  dynaRxBufferAddr := Dynamixel.GetRxBufferAddr
  'PingAndTest(controller[0])
  'PingAndTest(controller[1])
  byte[dynaBufferAddr] := controller[_Ax12Pan]
  byte[dynaBufferAddr + 1] := 0
  byte[dynaBufferAddr + 2] := 0
  byte[dynaBufferAddr + 3] := $FF
  byte[dynaBufferAddr + 4] := $03
  byte[dynaBufferAddr + 5] := controller[_AX12Tilt]
  byte[dynaBufferAddr + 6] := $33
  byte[dynaBufferAddr + 7] := $01
  byte[dynaBufferAddr + 8] := $CD
  byte[dynaBufferAddr + 9] := $02
  Dynamixel.SyncWrite(2, 6, 4)
  byte[dynaBufferAddr] := controller[_Ax12Pan]
  byte[dynaBufferAddr + 1] := _MidAX12 // $100
  byte[dynaBufferAddr + 2] := _MidAX12 / $100
  byte[dynaBufferAddr + 3] := _InitSpeed // $100
  byte[dynaBufferAddr + 4] := _InitSpeed / $100
  byte[dynaBufferAddr + 5] := _DefaultTorque // $100 
  byte[dynaBufferAddr + 6] := _DefaultTorque / $100 
  byte[dynaBufferAddr + 7] := controller[_AX12Tilt]
  byte[dynaBufferAddr + 8] := _MidAX12 // $100
  byte[dynaBufferAddr + 7] := _MidAX12 / $100
  byte[dynaBufferAddr + 9] := _InitSpeed // $100
  byte[dynaBufferAddr + 10] := _InitSpeed / $100
  byte[dynaBufferAddr + 11] := _DefaultTorque // $100
  byte[dynaBufferAddr + 12] := _DefaultTorque / $100
  Dynamixel.SyncWrite(2, 30, 6)

  
  'repeat localIndex from 0 to 1
    'localTargetP[localIndex] := _MidAX12
    'localTargetS[localIndex] := _MidAX12
    'localPosition[localIndex] := _MidAX12
    'targetSpeed[localIndex] := _MidAX12
    
  repeat
    watchLoop++
    repeat localIndex from 0 to 1
      'localOldTP[localIndex] := localTargetP[localIndex]
      'localOldTS[localIndex] := localTargetS[localIndex]
      'localOldP[localIndex] := localPosition[localIndex]
      'localOldS[localIndex] := targetSpeed[localIndex]
      presentPosition[localIndex] := Dynamixel.ReadData(controller[localIndex], 36, 6)
      presentSpeed[localIndex] := byte[dynaRxBufferAddr + 7] + (byte[dynaRxBufferAddr + 8] * $100)
      globalTorque[localIndex] := byte[dynaRxBufferAddr + 9] + (byte[dynaRxBufferAddr + 10] * $100)
      'if localTorque[localIndex] == _DefaultTorque
      localTemp := ||(localPosition[localIndex] - targetPosition[localIndex])
      localTargetS[localIndex] := localTemp * _SpeedPerDistance
      targetSpeed[localIndex] := 0 #> localTargetS[localIndex] <# _MaxSpeed
    byte[dynaBufferAddr] := controller[_Ax12Pan]
    byte[dynaBufferAddr + 1] := targetPosition[_Ax12Pan] // $100
    byte[dynaBufferAddr + 2] := targetPosition[_Ax12Pan] / $100
    byte[dynaBufferAddr + 3] := targetSpeed[_Ax12Pan] // $100
    byte[dynaBufferAddr + 4] := targetSpeed[_Ax12Pan] / $100
    byte[dynaBufferAddr + 5] := controller[_AX12Tilt]
    byte[dynaBufferAddr + 6] := targetPosition[_AX12Tilt] // $100   
    byte[dynaBufferAddr + 7] := targetPosition[_AX12Tilt] / $100   
    byte[dynaBufferAddr + 8] := targetSpeed[_AX12Tilt] // $100
    byte[dynaBufferAddr + 9] := targetSpeed[_AX12Tilt] / $100
    Dynamixel.SyncWrite(2, 30, 4)
   
DAT
  
'0:telephoto
IR00 long  $00045607, $0006613C, $0006FDF5, $0007738C, $00080F2B, $000990BC, $000A2D4F, $000AA33C, $000B3DC9, {
         } $000BB2DC, $000C4DCD, $000CC2BC, $000D5DE8, $000DD24C, $000E6D86, $000EE21C, $000F7DB2, $000FF20C, {
         } $00108C88, $0011016C, $00119C6E, $0012115C, $0012AC64, $0013204C, $0013BC2A, $001430CC, $0014CB54, {
         } $0015402C, $0015DB3F, $001755CC, $0017F8C1, $00186F7C, $00190A44, $00197F0C, $001A1A1C, $001A8EEC, {
         } $001B2921, $001B9EEC, $001C394C, $001CAEAC, $001D491E, $001DBE2C, $001E58AC, $001FD8EC, $00207611, {
         } $0021F9EC, $0022966E, $002418BC, $0024B5FF, $00252BCC, $0025C724, $00263B5C, $0026D65C, $00274B8C, {
         } $0027E6A9, $00285B4C, $0028F63D, $002A775C, $002B1408, $002B8A9C, $002C2532, $002C99DC, $002D34D4, {
         } $002DA9FC, $002E449D, $002EB93C, $002F5480, $002FC8FC, $00306400, $0031E4CC, $00328209, $0032F82C, {
         } $0033932B, $003407DC, $0034A2A6, $003517FC, $0035B2BF, $003732FC, $0037D074, $0039522C, $0039F03C, {
         } $003A668C, $003B0155, $003B767C, $003C1117, $003D91CC, $003E2EDF, $003EA52C, $003F404D, $0040C0AC, {
         } $00415E20, $0042D9DC, $00437DEB, $0043F44C, $00448EEC, $0045035C, $00459E80, $0046134C, $0046AE86, {
         } $00A1554C, $00A5AA38, $00A7B4EC, $00A8516B, $00A8C74C, $00A962B4, $00AAD97C, $00AB8042, $00ABF66C, {
         } $00AC9237, $00AD062C, $00ADA14D, $00AE15EC, $00AEB0FF, $00AF24CC, $00AFC0AC, $00B0349C, $00B0D080, {
         } $00B1470C, $00B1E047, $00B254FC, $00B2EFA2, $00B3643C, $00B4002A, $00B4741C, $00B50FA5, $00B5833C, {
         } $00B61F56
{1:wide}
IR01 long  $00045652, $00065D45, $0006FDD6, $000773A5, $00080E75, $00098EC5, $000A2CE6, $000AA3A5, $000B3DF7, {
         } $000BB455, $000C4D7F, $000CC245, $000D5D4B, $000DD215, $000E6D17, $000EE135, $000F7D0D, $000FF0F5, {
         } $00108C8B, $00110045, $00119BDD, $00121175, $0012ABA1, $00132155, $0013BB6F, $00142F15, $0014CB0C, {
         } $00153FA5, $0015DA8B, $00175BF5, $0017F922, $00186F55, $00190A49, $00197F15, $001A1A03, $001A8EB5, {
         } $001B29C9, $001B9EA5, $001C392F, $001CAE95, $001D48F1, $001DBE05, $001E589E, $001FD975, $00207724, {
         } $0021F175, $00229685, $002418A5, $0024B63F, $00252D55, $0025C6E1, $00263B95, $0026D6CF, $00274B75, {
         } $0027E683, $00285B35, $0028F65C, $002A7695, $002B14F1, $002B8A85, $002C24D5, $002C9AC5, $002D34A8, {
         } $002DA975, $002E4492, $002EB875, $002F542E, $0030D4B5, $00317261, $0032EF25, $00339288, $00340895, {
         } $0034A371, $00351825, $0035B2EC, $003627B5, $0036C25F, $00384635, $0038E101, $003A6395, $003B00E4, {
         } $003B76E5, $003C1191, $003D8DA5, $003E3002, $003FB1E5, $00404F45, $0040C555, $0041601C, $0042DA85, {
         } $00437EB1, $004500E5, $00459E67, $00461495, $0046AED7, $00472425, $0047BF2D, $00483355, $0048CE20, {
         } $00A376F5, $00A7CBD2, $00A9D4A5, $00AA72EB, $00AAE8B5, $00AB83C3, $00ACFE75, $00ADA1AC, $00AE17A5, {
         } $00AEB34F, $00AF27D5, $00AFC323, $00B037D5, $00B0D262, $00B14675, $00B1E2B1, $00B25745, $00B2F23B, {
         } $00B366C5, $00B401EA, $00B47645, $00B51155, $00B585F5, $00B62151, $00B69635, $00B730E7, $00B7A625, {
         } $00B84083
'3:DATE/TIME
IR03 long  $00045435, $00066737, $000703ED, $00077957, $00080C28, $00099557, $000A32B6, $000AA897, $000B3B1F, {
         } $000BB7F7, $000C4AC2, $000CC7B7, $000D5AB8, $000DD6F7, $000E6AB9, $000EE787, $000F7A8F, $000FF757, {
         } $00108A8D, $001106D7, $00119B30, $001216B7, $0012A99C, $00132667, $0013B948, $00143617, $0014C8DD, {
         } $00154637, $0015D8BC, $001763E7, $0017FEDB, $001874D7, $00190818, $00198567, $001A18B2, $001A94A7, {
         } $001B2919, $001BA3B7, $001C389B, $001CB427, $001D487E, $001DC3D7, $001E5D19, $001FE177, $00207CA3, {
         } $00220017, $00229C3E, $002420A7, $0024BBB9, $00253207, $0025C83A, $002642E7, $0026DAEF, $00275157, {
         } $0027EA3A, $00286177, $0028FFB1, $002A7EB7, $002B1A15, $002B9067, $002C2FE2, $002CA047, $002D3B9A, {
         } $002DAF77, $002E4F8A, $002EBF37, $002F5D49, $0030DC97, $00317848, $0032FBB7, $00339781, $00351B57, {
         } $0035B773, $00362E07, $0036CD5D, $00373E17, $0037DCDD, $00395A77, $0039F6CB, $003B7A17, $003C15E8, {
         } $003C8CB7, $003D2E5D, $003EA937, $003F4561, $0040C957, $004164AD, $0042E8B7, $00438439, $00450817, {
         } $0045A417, $00472867, $0047C369, $00483A57, $0048D9E2, $004949F7, $0049E487, $004A5987, $004AFAA2, {
         } $00A59C67, $00A9EB6F, $00ABFDF7, $00AC9B1D, $00AD10D7, $00ADA397, $00AF2CB7, $00AFC988, $00B03FB7, {
         } $00B0D291, $00B14EC7, $00B1E305, $00B25F87, $00B2F224, $00B36F57, $00B401FF, $00B47F07, $00B511B0, {
         } $00B58E67, $00B62179, $00B69F37, $00B73165, $00B7AE27, $00B840F8, $00B8BD27, $00B9506D, $00B9CD17, {
         } $00BA606B
'4:Photo Shot
IR04 long  $000454BE, $00065B52, $0006FBE4, $000771A2, $00080D24, $00098E42, $000A2A89, $000AA1B2, $000B3C60
     long  $000BB152, $000C4C0B, $000CC112, $000D5BAB, $000DD092, $000E6B77, $000EE092, $000F7AE0, $000FF032
     long  $00108A61, $00110012, $00119A71, $00120F72, $0012AA37, $00131F32, $0013B9AC, $00142F42, $0014C94B
     long  $00153EA2, $0015D8EA, $00175972, $0017F5A7, $00186CA2, $00190813, $00197D22, $001A181B, $001A8CE2
     long  $001B2738, $001B9D02, $001C36F4, $001CAC52, $001D46BF, $001DBC12, $001E5629, $001FD922, $002072FB
     long  $0021F872, $002292C0, $00241712, $0024B230, $002529C2, $0025C481, $00263A12, $0026D422, $00274972
     long  $0027E3E8, $002859C2, $0028F3B5, $002A7612, $002B1079, $002B8842, $002C22B5, $002C9802, $002D32DC
     long  $002DA802, $002E41F7, $002EB772, $002F5191, $002FC792, $003061AD, $0031E3D2, $00327E85, $00340052
     long  $00349DD0, $00351622, $0035AFDA, $00362592, $0036C05B, $003841C2, $0038DD06, $003A56E2, $003AFC98
     long  $003B7472, $003C0EC4, $003C8412, $003D1E4F, $003E9FA2, $003F3B16, $0040BFE2, $00415ABC, $0042DFF2
     long  $00437A48, $0044FE92, $004599C8, $00461142, $0046AC74, $00472172, $0047BBCF, $00483182, $0048CB91
     long  $00A37322, $00A7CB42, $00A9C742, $00AA6EFA, $00AAE5A2, $00AB809E, $00AD00E2, $00AD9E44, $00AE14F2
     long  $00AEB034, $00AF22E2, $00AFBFA0, $00B033B2, $00B0CEDB, $00B14402, $00B1DF48, $00B253A2, $00B2EEFA
     long  $00B36312, $00B3FE9B, $00B47352, $00B50E6D, $00B582A2, $00B61DB7, $00B69242, $00B72D7B, $00B7A182
     long  $00B83DCB
'5:Start/Stop
IR05 long  $000453A8, $00065D7A, $0006FB38, $000770DA, $00080C09, $00098D4A, $000A299B, $000AA03A, $000B3B70
     long  $000BB01A, $000C4AEA, $000CBF0A, $000D5AB9, $000DCF2A, $000E6A39, $000EDE0A, $000F79C6, $000FEE4A
     long  $00108A58, $0010FEEA, $001199D0, $00120E6A, $0012A95A, $00131D8A, $0013B903, $00142E0A, $0014C933
     long  $00153DBA, $0015D873, $001759EA, $0017F51B, $00186D1A, $001907A3, $00197BBA, $001A17AD, $001A8C2A
     long  $001B276D, $001B9BCA, $001C36BB, $001CAB9A, $001D46CC, $001DBA7A, $001E56DF, $001FD6CA, $002072E8
     long  $0021F5BA, $00229248, $0024172A, $0024B218, $0025292A, $0025C463, $0026394A, $0026D4D9, $0027496A
     long  $0027E41B, $0028593A, $0028F43E, $002A75AA, $002B1053, $002B882A, $002C2333, $002C970A, $002D3302
     long  $002DA7BA, $002E428B, $002EB76A, $002F529A, $002FC6CA, $0030621B, $0030D68A, $003171E2, $0032F38A
     long  $00338E9F, $0035140A, $0035ADBE, $003624EA, $0036C0CD, $003734EA, $0037D0CF, $0039526A, $0039ED1E
     long  $003B71AA, $003C0C7F, $003C83BA, $003D1F3B, $003D93CA, $003E2FBE, $003FB0CA, $00404B6C, $0040C34A
     long  $00415E65, $0042DFCA, $00437A5A, $0044FFAA, $00459A9F, $004610DA, $0046AD20, $00482ECA, $0048C9B9
     long  $00A374DA, $00A7CBA4, $00A9CC8A, $00AA72B9, $00AAE8AA, $00AB845C, $00AD046A, $00ADA1D6, $00AE176A
     long  $00AEB377, $00AF27AA, $00AFC38A, $00B0370A, $00B0D34A, $00B146FA, $00B1E33A, $00B2568A, $00B2F2AA
     long  $00B366BA, $00B40237, $00B4764A, $00B511D3, $00B5867A, $00B62146, $00B6947A, $00B73138, $00B7A5BA
     long  $00B8418B
'6:Display
IR06 long  $00044F33, $00066261, $000706EE, $000773A1, $00080B60, $00098F11, $000A3491, $000AA3A1, $000B365A
     long  $000BB391, $000C47C2, $000CC311, $000D55C9, $000DD401, $000E65AB, $000EE2B1, $000F7B18, $000FF211
     long  $0010854F, $00110291, $00119502, $00121291, $0012A4C0, $001321B1, $0013B46E, $001431B1, $0014C9E4
     long  $001541B1, $0015D3FE, $00175F11, $0017FACA, $001870D1, $0019045F, $00198071, $001A16D9, $001A91A1
     long  $001B25AE, $001BA001, $001C376E, $001CAFE1, $001D4778, $001DBF91, $001E5C94, $001FDCD1, $00207795
     long  $0021FC21, $002296F6, $00241A81, $0024B626, $00252E01, $0025C9ED, $00263DC1, $0026DA64, $00274F21
     long  $0027EA58, $00285D91, $0028F9F5, $002A7871, $002B13A0, $002B8CE1, $002C2866, $002C9C51, $002D3D21
     long  $002DAC51, $002E46FA, $002EBBA1, $002F5C3B, $0030E691, $0031705F, $00330711, $00338ED3, $00340CB1
     long  $0034A416, $00351BC1, $0035B37B, $003751C1, $0037CCEC, $00384C01, $0038E190, $003A85A1, $003AFB95
     long  $003B7AE1, $003C0FEF, $003DB621, $003E2A64, $003FDD91, $00404965, $0040CA91, $00415D0F, $00430CD1
     long  $00437903, $0043F981, $00448B94, $00463C41, $0046A826, $00472A91, $0047BAFA, $004838A1, $0048CB54
     long  $00A3B561, $00A7C9AE, $00AA0381, $00AA6FB3, $00AAEFA1, $00AB818F, $00AD33F1, $00AD9ED4, $00AE2051
     long  $00AEB07B, $00AF2F71, $00AFC0C8, $00B04081, $00B0D0D1, $00B14E41, $00B1E0BC, $00B25EF1, $00B2F08C
     long  $00B36DA1, $00B40068, $00B47D61, $00B51046, $00B58D31, $00B62048, $00B69E21, $00B72FFF, $00B7ACE1
     long  $00B83FC3
{reset 98 longs}                                                                                            
IR07 long  $00041C41, $00064567, $0006C2F8, $00074337, $0007D806, $00095E57, $0009F256, $000A71D7, $000B0796
     long  $000B80F7, $000C1797, $000C90F7, $000D2793, $000DA097, $000E37C3, $000EB167, $000F4767, $000FBF87
     long  $0010578B, $0010CEF7, $00116742, $0011DFD7, $001276F6, $0012EEE7, $001386E2, $0013FF17, $00149655
     long  $00150EC7, $0015A64E, $00174467, $0017C007, $00183E67, $0018D56F, $00194F47, $0019E55B, $001A5DB7
     long  $001AF4CD, $001B6D97, $001C04DF, $001C7D47, $001D1451, $001D8CF7, $001E2463, $001FC487, $00203D74
     long  $0021E6E7, $00225CA7, $002406E7, $00247C40, $0024FD17, $00259106, $00260BF7, $0026A0DB, $00271C37
     long  $0027B0CA, $00282CC7, $0028C0E7, $002A65A7, $002ADAE4, $002B5AF7, $002BEFA7, $002C69D7, $002CFFAB
     long  $002D7957, $002E0F83, $002E8947, $002F1F98, $002F9987, $00302F49, $0030A9A7, $00313ECA, $0032E3C7
     long  $003358F1, $0033D967, $00346D6B, $00361377, $00368820, $003707D7, $00379C2B, $00394AF7, $0039B729
     long  $003A38B7, $003ACB3A, $003B4677, $003BDB35, $003C5637, $003CEB06, $003E9A17, $003F0634, $0040B9A7
     long  $00412559, $0041A6D7, $0042395A, $0043E8C7, $004454D2, $0044D6D7, $004567FD, $0045E4D7
'8:Title 
IR08 long  $00044F65, $00066084, $0006FC14, $00077494, $00080EA4, $00098E84, $000A2AF1, $000AA3F4, $000B3E41
     long  $000BB394, $000C4E26, $000CC3B4, $000D5DC8, $000DD394, $000E6D4C, $000EE2B4, $000F7D71, $000FF304
     long  $00108CF5, $00110304, $00119CB8, $001212A4, $0012AC85, $001321F4, $0013BC23, $001432A4, $0014CCCE
     long  $00154294, $0015DC9E, $00175CF4, $0017F7B3, $001870E4, $00190B1D, $00198294, $001A1BEB, $001A91D4
     long  $001B2C38, $001BA174, $001C3C66, $001CAFE4, $001D4AF9, $001DC0D4, $001E5B27, $001FDB14, $00207585
     long  $0021FAD4, $002294CB, $00241A04, $0024B440, $00252E44, $0025C9BB, $002749B4, $0027E3AD, $00285DB4
     long  $0028F8D3, $00296CA4, $002A0881, $002B87B4, $002C2336, $002C9C14, $002D38D8, $002DABE4, $002E47E7
     long  $002EBBF4, $002F584E, $002FCB54, $003069D0, $0030DB04, $00317C52, $0032F794, $003391BD, $00351714
     long  $0035B126, $00362A34, $0036CB61, $003846F4, $0038E082, $003A6614, $003B001C, $003C8444, $003D1F79
     long  $003D98E4, $003E3961, $003FB3B4, $00404EE7, $0041D394, $00426E38, $0043F394, $00448DCC, $00461324
     long  $0046AD2B, $00472754, $0047C313, $00483674, $0048D2B1, $00494684, $0049E43A, $004A58D4, $004AF590
     long  $00A5D594, $00A9E93C, $00AC1EE4, $00AC8F1B, $00AD0EB4, $00ADA2D0, $00AF4C04, $00AFBEBE, $00B03F34
     long  $00B0D2CE, $00B14E14, $00B1E30D, $00B25E84, $00B2F414, $00B36D44, $00B403CD, $00B47CA4, $00B513F4
     long  $00B58CC4, $00B623DF, $00B69C24, $00B733F7, $00B7ABD4, $00B843F0, $00B8BBB4, $00B953BC, $00B9CAF4
     long  $00BA639B
'24:Off/On
IR24 long  $0004548D, $00065D09, $0006FBBE, $00077139, $00080CE5, $00098E19, $000A2A62, $000AA089, $000B3BC7 
     long  $000BAFB9, $000C4C6C, $000CBFE9, $000D5B49, $000DCFB9, $000E6B44, $000EDF69, $000F7A70, $000FEEE9 
     long  $00108A95, $0010FF09, $00119AD6, $00120F59, $0012A97A, $00131E59, $0013B96B, $00142E29, $0014C931 
     long  $00153DF9, $0015D8B8, $00175B39, $0017F4FF, $00186CC9, $001907D1, $00197C79, $001A1813, $001A8C59 
     long  $001B273D, $001B9C09, $001C36DD, $001CABB9, $001D4681, $001DBB89, $001E568E, $001FD799, $00207284 
     long  $0021F7C9, $00229276, $00241749, $0024B23D, $00252979, $0025C4DC, $002744D9, $0027E1AD, $00285859 
     long  $0028F43E, $00296869, $002A0311, $002B83B9, $002C204D, $002C9919, $002D32D0, $002DA719, $002E4213 
     long  $002EB699, $002F52C0, $002FC679, $003061B8, $0030D679, $00317108, $0031E5E9, $00328121, $0032F579 
     long  $0033908F, $00340549, $0034A0C1, $00362189, $0036BD07, $00384099, $0038DC8D, $003A6039, $003AFC16 
     long  $003B7389, $003C0E5C, $003D8EC9, $003E2B79, $003EA279, $003F3DCD, $003FB289, $00404DDD, $0041CE79 
     long  $00426AC1, $0042E149, $00437CF2, $0043F119, $00448CE9, $00450139, $00459C35, $00461109, $0046AC42 
     long  $00A151E9, $00A5A7C4, $00A7B099, $00A85365, $00A8C649, $00A95FD0, $00AADD89, $00AB7E26, $00ABF3E9 
     long  $00AC8FB9, $00AD04B9, $00AD9E2B, $00AE13D9, $00AEAEDC, $00AF23B9, $00AFBE81, $00B03299, $00B0CEB0 
     long  $00B142B9, $00B1DDB4, $00B25259, $00B2EDD4, $00B36269, $00B3FD94, $00B472D9, $00B50D9B, $00B580F9 
     long  $00B61CD2
        